## ##############################################################################################
##
## Copyright 2012 CNRS, INPT
##  
## This file is part of qr_mumps.
##  
## qr_mumps is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as 
## published by the Free Software Foundation, either version 3 of 
## the License, or (at your option) any later version.
##  
## qr_mumps is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##  
## You can find a copy of the GNU Lesser General Public License
## in the qr_mumps/doc directory.
##
## ##############################################################################################


## -*- Makefile -*-
##
## $Date: 2016-07-07 22:22:30 +0100 $
## $Author: sagitter AT fedoraproject.org $
## $Version: 1.1$
## $Revision: 1 $
##


# write here the path to the qr_mumps top directory
topdir=$(HOME)/path/to/here

LINK    = $(FC)

CC      = gcc
FC      = gfortran

# remove the -fopenmp flag if you want a sequential version
FCFLAGS  = -O3 -fopenmp -fPIC
CFLAGS   = -O3 -fPIC

LDFLAGS  = $(FCFLAGS)
INCLUDES = -I. -I../include $(INCBLAS)
# CINCLUDES= $(IMETIS) $(ICOLAMD) $(ISTARPU)
CINCLUDES= $(IMETIS) $(ICOLAMD)
FINCLUDES= $(ISCOTCH)

# this variable is for compilers that need a prefix before the -D flag (i.e., xlf)
DEFINE_PREPEND = 

# you can specify here what ordering tools you have and if you want or not StarPU parallelism
# CDEFS = -Dhave_metis -Dhave_scotch -Dhave_colamd -Dhave_starpu 
# FDEFS = -Dhave_metis -Dhave_scotch -Dhave_colamd -Dhave_starpu
CDEFS = -Dhave_metis -Dhave_scotch -Dhave_colamd 
FDEFS = -Dhave_metis -Dhave_scotch -Dhave_colamd 

AR = ar -cur
RANLIB = ranlib

# your StarPU library
# LSTARPU = -L/path/to/starpu -lstarpu
# ISTARPU = -I/path/to/starpu/include

LBLAS    =  $(LIBBLAS)
LLAPACK  =  $(LIBLAPACK)

# your COLAMD library
LCOLAMD  = -lcolamd
ICOLAMD  = -I/usr/include/suitesparse

# your METIS library
LMETIS   = -lmetis
IMETIS   = -I/usr/include

# your scotch library
LSCOTCH  = -lscotch -lscotcherr
ISCOTCH  = -I/usr/include

LIBS =	$(LLAPACK) $(LBLAS) \
        $(LCOLAMD) $(LMETIS) \
	$(LSCOTCH) -lpthread

%.mod: %.o
	@true

%.o: %.c
	$(CC)  $(CFLAGS)  $(CINCLUDES) $(INCLUDES) $(CDEFS) $(PREC) -c $<
%.o: %.f
	$(FC)  $(FCFLAGS) $(FINCLUDES) $(INCLUDES) $(FDEFS) $(DEFINE_PREPEND)$(PREC) -c $<
%.o: %.f90				       
	$(FC)  $(FCFLAGS) $(FINCLUDES) $(INCLUDES) $(FDEFS) $(DEFINE_PREPEND)$(PREC) -c $<
%.o: %.F
	$(FC)  $(FCFLAGS) $(FINCLUDES) $(INCLUDES) $(FDEFS) $(DEFINE_PREPEND)$(PREC) -c $<
%.o: %.F90
	$(FC)  $(FCFLAGS) $(FINCLUDES) $(INCLUDES) $(FDEFS) $(DEFINE_PREPEND)$(PREC) -c $<
